ReferencePolicyOption
Date: 2016-06-25

org.osgi.service.component.annotations

## Enum ReferencePolicyOption

- java.lang.Object
- - java.lang.Enum<ReferencePolicyOption>
  - - org.osgi.service.component.annotations.ReferencePolicyOption

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<ReferencePolicyOption>

      public enum ReferencePolicyOption
      extends java.lang.Enum<ReferencePolicyOption>

  Policy option for the `Reference` annotation.
  Since:
    1.2

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `GREEDY` The greedy policy option is a valid policy option for both `static` and `dynamic` reference policies.
    `RELUCTANT` The reluctant policy option is the default policy option for both `static` and `dynamic` reference policies.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `toString()`
    `static ReferencePolicyOption` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static ReferencePolicyOption[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### RELUCTANT

          public static final ReferencePolicyOption RELUCTANT

      The reluctant policy option is the default policy option for both `static` and `dynamic` reference policies. When a new target service for a reference becomes available, references having the reluctant policy option for the static policy or the dynamic policy with a unary cardinality will ignore the new target service. References having the dynamic policy with a multiple cardinality will bind the new target service.

    - #### GREEDY

          public static final ReferencePolicyOption GREEDY

      The greedy policy option is a valid policy option for both `static` and `dynamic` reference policies. When a new target service for a reference becomes available, references having the greedy policy option will bind the new target service.

  - ### Method Detail

    - #### values

          public static ReferencePolicyOption[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ReferencePolicyOption c : ReferencePolicyOption.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ReferencePolicyOption valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Enum<ReferencePolicyOption>`